$chip(Z80)
$paginate
$pagewidth=150
$title(ST-8000 TEST ROUTINES)
$subtitle(definitions)

;	file name:	STTEST.M80
;	last changed:	15 OCT 85
;	changed by:	ABW

;	copyright (c) 1985 HAL COMMUNICATIONS CORP


;  REVISION HISTORY GOES HERE >>>>

;	v1.1	change for rev b front panel board  rd 9-5-86
;	V1.2	add latch debug options		    JKC 7-29-87



;.mcall	.mcz80
;	.mcz80

;	comment out the next line for non-test mode

;test	equ	$ff; comment out for 0000 based rom

test	equ	1	;asm
;test	equ	0	;asm

;xxx	equ	1	;asm
xxx	equ	0	;asm

cr	equ	0dh
lf	equ	0ah
   
verhi	equ	1
verlo	equ	0
verx	equ	12h

	%if	test	eq	1

rom	equ	1100h	; set the test start location
romlen	equ	2000h	; set the length for first 8k
ram	equ	6000h

ramend	equ	high ram+8	;rd  ram length

	%else
rom	equ	0000h	; real version
romlen	equ	2000h	; set the length for first 8k
ram	equ	6000h

ramend	equ	hihg ram+8	;rd  ram length
	%endif

b7	equ	7	; some bit flags
b6	equ	6
b5	equ	5
b4	equ	4
b3	equ	3
b2	equ	2
b1	equ	1
b0	equ	0

;	input definitions and literals.  most switches are located at
;	a single bit of an input address.  the following list is divided
;	by the input location.

;	input switch 1

in0	equ	00h

ptttx	equ	b7	; 0 to select the tx ptt - stb:ptta,pttb
pttrx	equ	b6	; 0 to select the rx ptt
selbd	equ	b5	; these 4 are for the tune select
selspa	equ	b4	; tuner mode: trkequ1,mrkequ2,spaequ3,bdequ4
selmrk	equ	b3
seltrk	equ	b2
potb	equ	b1	; softpot b input
pota	equ	b0	; softpot a input


;	input switch 2

in1	equ	04h

norrev	equ	b7	; 0 for normal - bpq:norm
mstore	equ	b6	; 0 for store memory
mem3	equ	b5	; 0 to select memory 3
mem2	equ	b4	; memsel: mem1equ1, mem2equ2, mem3equ3
mem1	equ	b3
mrmt	equ	b2	; 0 to select memory for t and r
vrmt	equ	b1	; 0 for var rx, mem tx
vrvt	equ	b0	; 0 for var rx, var tx


;	input switch 3

in2	equ	08h

fminp	equ	b7	; 0 means use FM limiter - stb:amfm
msinp	equ	b6	; 0 for mark/space - stb:detmb,detma
mpinp	equ	b5	; 0 for multi-path correction
moinp	equ	b4	; 0 for mark only
soinp	equ	b3	; 0 for space only input
spdsp	equ	b2	; 0 for display space frequency
mkdsp	equ	b1	; 0 for display mark frequency
aspinp	equ	b0	; 0 for antispace off. - stb:antisp


;	input switch 4

in3	equ	0ch

atrk	equ	b7	; 0 for autotrack ctrl
autobd	equ	b6
bddsp	equ	b5	; 0 for ibaud, 1 for obaud display
rgbb	equ	b4	; regen options - numbered fro 5 to 1
rgba	equ	b3
rgoff	equ	1bh	;11 off position equ 0
rgab	equ	b1
rgaa	equ	b0


;	output control latch

stb	equ	0e000h	; output control latch

prtb	equ	b7	; 1 to turn on the printer. 0 for auto
amfm	equ	b6	; 0 for fm - in2:fminp
detmb	equ	b5	; ba: 00-SO, 01-MO, 10-MP, 11-M/S - in2:msinp-soinp
detma	equ	b4
antisp	equ	b3	; 0 for off 1 for on - in2:aspinp
pttb	equ	b2	; ba: 00-KOS, 01-RX, 10-TX, 11-TX - in0:ptttx,pttrx
ptta	equ	b1
cts	equ	b0	; terminal port CTS signal 0 to turn ON

sanity	equ	0e007h	; deadstart timer...

;	various output latch strobes.  mostly easy to identify
;	display output latches

mkshl	equ	08000h	; mark low shift byte
dsseg	equ	08001h	; segment register
spshl	equ	08002h	; space tone low byte
spshh	equ	08003h	; space tone high byte
mkbpl	equ	08004h	; mark bandpass low byte
mkbph	equ	08005h	; mark bandpass high byte
spbpl	equ	08006h	; space bandpass low byte
spbph	equ	08007h	; space bandpass high byte

bpl	equ	0a000h	; band pass low
bph	equ	0a001h	; band pass high byte
lpl	equ	0a002h	; low pass low byte
lph	equ	0a003h	; low pass high byte
mkdig	equ	0a044h	; mark digits
spdig	equ	0a045h	; space digits
bddig	equ	0a004h	; baud rate digits
dspdig	equ	0a005h	; digits select (b7equdig1)
mkspq	equ	0a006h	; special latch strobe
			; mark q: b0-b3, space q: b4-b7

;	bandpass q and other latch

bpq	equ	0a007h	; special latch strobe
			; bp q: b0-b3

qmkhl	equ	b6	; high low q for mark filter - 1 is high 
qsphl	equ	b5	; high low q for space filter - 1 is high 
crtb	equ	b4	; set the crt control bit
rxrgen	equ	b3	; 0 means regeneration enabled
norm	equ	b2	; 0 for normal mode

idelay	equ	0200h	; initial on delay
vdelay	equ	0080h	; and the version display


c0	equ	0fch	; 0
c1	equ	060h	; 1
c2	equ	0dah	; 2
c3	equ	0f2h	; 3
c4	equ	066h	; 4
c5	equ	0b6h	; 5
c6	equ	0beh	; 6
c7	equ	0e0h	; 7
c8	equ	0feh	; 8
c9	equ	0f6h	; 9
ca	equ	0eeh	; A
cha	equ	10
cb	equ	03eh	; b
chb	equ	11
cc	equ	09ch	; C
chc	equ	12
cd	equ	07ah	; d
chd	equ	13
ce	equ	09eh	; E
che	equ	14
cf	equ	08eh	; F
chf	equ	15
ch	equ	06eh	; H
chh	equ	16
c.	equ	1h	; period
ch.	equ	17
co	equ	00h	; all off
chsp	equ	18
cdsh	equ	02h	; minus sign
chdsh	equ	19
cl	equ	01ch	; L
chl	equ	20
ct	equ	01eh	; t
cht	equ	21
		
;	io control and status locations
;	control port first

costat	equ	1dh	; console status
codata	equ	1ch	; console data reg

crxrdy	equ	04h	; rxrdy for control port
ctxrdy	equ	01h	; txrdy for control port

force	equ	82h	; force reset filler
reset	equ	40h	; reset command
ereset	equ	10h	; error reset
iofpe	equ	38h	; error flags
txrxen	equ	27h	; enable outputs and rx tx paths
comdw	equ	4eh	; 8 bits, 1 stop, no parity, x16 clock


;	regeneration port literals

txdata	equ	18h	; transmit direction 
txstat	equ	19h	; status

rxdata	equ	1ah	; receive direction data
rxstat	equ	1bh	; status

reg1	equ	01h	; reg values
reg2	equ	02h
reg3	equ	03h
reg4	equ	04h
reg5	equ	05h

preset	equ	18h	; port reset
eires	equ	10h	; external interrupt reset

rxrdy	equ	01h	; rr0 rx data ready
txrdy	equ	04h	; rr0 tx ready


;	for the brg, the divisor is 1228800/(rate)

brg0	equ	14h	; timer 0
brg1	equ	15h	; timer 1
brgnmi	equ	16h	; nmi timer
brgctl	equ	17h	; timer control register

brnmi	equ	1228*4	; divisor for 250Hz refresh rate

br0mdw	equ	36h	; set square wave mode for terminal data
br1mdw	equ	76h	; set square wave mode for modem data
nmimdw	equ	0b6h	; set square wave mode for nmi also

nmiena	equ	10h	; b0 will control the nmi output - eventually

r1200	equ	64	; 1200 bps constant
r150	equ	512	; 100 bps setting

;	.page
$subtitle(ram memory assignments)

;	ram memory is currently broken into two sections.


	defseg	program,absolute
	seg	program

	org	ram

stackst	ds	64	; leave room for the stack
stack	ds	1

dsplrx:
dmkrx:	ds	4	; mark freq display
dsprx:	ds	4	; space freq display
dbdrx:	ds	4	; baud freq display

cksum:	ds	3	; place for the checksum output
tick:	ds	1	; display increment timer

;	storage for the memory selections

istb:	ds	1	; internal stb status
imkspq:	ds	1	; internal mkspq status
ibpq:	ds	1	; internal bpq status

pstate:	ds	1	; soft pot setting
tuner:	ds	1	; tune save
rtmode:	ds	1
memsel:	ds	1
rgmode:	ds	1
txdsav:	ds	1
rxdsav:	ds	1
storeb:	ds	1
temp:	dw	1
dspsel:	ds	1


btest:	dw	1	; for battery test
btflg:	ds	1
ttest:	dw	1	; for timer test
ttflg:	ds	1

iin0:	ds	1	; current valid input
iin1:	ds	1
iin2:	ds	1
iin3:	ds	1

ciptr:	dw	1	; console input buffer pointer

cmdbuf:	ds	82	; command buffer storage
cmdptr:	dw	1	; command buffer pointer
cmdsav:	dw	1	; command string pointer for processing

pmtptr:	dw	1	; pointer to the prompt display routine
pmterr:	ds	1	; 0:none, 1:unkwn cmd, 2:cmd not valid here
jvalue:	dw	1	; store pointer for fvalue routine

msgptr:	dw	1	; qbf output msg pointer


;	.page
$subtitle(start of the program)

	%if	test	eq	1

	org	0000		; test and none test are the same...
	jmp	rom

	org	0066h		; set the jump to nmi
	jmp	nmi

	%endif


; the start of the program is always set to 1100h to be compatible
; with the debug routine.

	org	rom
	di

	xra	a		; turn off the nmi interrupt
	out	nmiena

	lxi	sp,stack

;	set the vector

	mvi	a,high rtvec	; set the upper byte value
	stai			; and load the intr variable

	jmp	start


;	vector table for regen port
;	must start on even paragraph boundary

	org	rom+10h		; set to even boundary

rtvec:	dw	ignore		; channel B - rxdata input
	dw	ignore		; turn off external interrupts
	dw	rxdin		; rx data input intr
	dw	rxderr		; error routine

	dw	ignore		; channel A - txdata input
	dw	ignore		; turn off external interrupts
	dw	txdin		; tx data input intr
	dw	txderr		; error routine


;	initial table for the regen ports.  used to load ram vars
;	channel A

tx_def:	db	0		; ascii code
	db	01ch		; intr all rx, pe diff/status enab/tx int disable
	db	low rtvec 	; load the low vector table byte
	db	0c1h		; 8 bits, rx/rx enable
	db	044h		; x16 clock/1 stop bit/no parity
	db	0eah		; dtr on/8 bits tx/tx enable/rts on

;	channel B

rx_def:	db	0		; ascii code
	db	01ch		; intr all rx, pe diff/status enab/tx int disable
	db	low rtvec  	; load the low vector table byte
	db	0c1h		; 8 bits, rx/rx enable
	db	044h		; x16 clock/1 stop bit/no parity
	db	0eah		; dtr on/8 bits tx/tx enable/rts on


;	conversion table for internal code to display code
;	offset into the table to read the proper display code

dtab:	db	c0,c1,c2,c3
	db	c4,c5,c6,c7
	db	c8,c9,ca,cb
	db	cc,cd,ce,cf
	db	ch,c.,co,cdsh
	db	cl,ct

;	.page
$subtitle(nmi routine)

;	nmi refreshes the display once eachm 12 ms by moving
;	thru each of the 12 digits at a 1 ms rate.
;	nmi happens each 1 ms (about)

	org	rom+66h		; set the nmi routine

nmi:	exaf			; get to the other set of regs
	exx

	lxi	h,tick
	inr	m

	lxi	h,dsplrx	; set to the rx base

	inr	d		; increment the digit pointer
	mov	a,d		; read it
	ani	3		; save two bits
	mov	d,a		; and put it back
	jnz	a15		; if not zero, skip the e reg reset
	mvi	e,10h		; select first digit location

a15:	add	l		; add the offset to display message base
	mov	l,a		; and put it back

	mov	a,m		; read the digit value
	sta	mkdig		; and display it

	inr	l		; skip to the next digit location
	inr	l		; have to increment by 4
	inr	l
	inr	l
	mov	a,m		; read that one
	sta	spdig		; and show it

	inr	l		; now the baud display
	inr	l
	inr	l
	inr	l		; done
	mov	a,m		; read that value
	sta	bddig		; and set the output

	mov	a,e		; get the current digit pointer
	sta	dspdig		; then turn on one set of digits
	rlcr	e		; rotate digit select left

a40:	exaf
	exx
	retn			; then exit

;	.page
$subtitle(nmi init, init, console init)

;	init the nmi routine variables...
;	first the timer...

nminit:	mvi	a,nmimdw	; set up the nmi counter
	out	brgctl		; store at the control address
	mvi	a,low brnmi	; load the low byte
	out	brgnmi
	mvi	a,high brnmi	; now the high byte
	out	brgnmi

;	now set the initial pointers for the display

	exx
	lxi	h,dsplrx	; set to the rx display
	lxi	d,1000h
	exx

	mvi	a,1		; now, start the nmi timer, for better or...
	out	nmiena

	ret


cmsg:	db	8,88h,8,8
	db	8,88h,8,8
	db	8,8,8,8
	db	$ff

imsg:	db	chh,cha,chl,chsp
	db	8,0,0,0
	db	cht,chdsh,verhi+80h,verlo
	db	$ff


swinit:	sta	sanity

	in	in0		; read the input switch
	sta	iin0

	in	in1
	sta	iin1

	in	in2
	sta	iin2

	in	in3
	sta	iin3

	lda	iin0		; read the current pot setting
	ani	3h		; if 00 set to ps00, if 11 set to ps11
	sta	pstate		; store this initial value

	ret


;	before doing anything else, load a message for the display to show.
;	this message will stay as long as the machine waits here -
;	will be a display test, and show the software version

er0msg:	db	"\r\n\n"
	db	">>>  ROM Checksum Error   "
	db	$ff

init:	sta	sanity

	lxi	h,cmsg		; turn all on
	call	outd0

;	now wait a bit before going on...

	lxi	h,idelay	; set a delay variable
b20:	sta	sanity
	djnz	b20		; loop 256 times
	dcx	h		; dec the timer
	mov	a,h		; test for the end
	ora	l
	jrnz	b20		; and loop til done...


;	now load the version message

	lxi	h,imsg		; load the message for display
	call	outd0		; show the message

;	calc the checksum over all of the rom...

	lxi	h,rom		; set the start
	lxi	b,romlen	; set the 8k rom length
	xra	a		; clear the sum byte
b30:	sta	sanity
	add	m		; add in the byte
	cci			; dec hl, dec bc
	jpe	b30		; loop til done...


;	acc has the checksum.  if not zero, have to show what the
;	value should be.

	ana	a		; if zero, continue
	jrz	b40


;	value is not zero, so must show the invalid check sum

	lxi	h,cksum		; set a pointer
	cma			; invert it
	mov	b,a		; and save for a bit
	rrc			; get the high byte first
	rrc
	rrc
	rrc
	ani	0fh		; save 4 bits
	mov	m,a		; save the first one
	inx	h		; increment the pointer
	mov	a,b		; recover the sum
	ani	0fh		; save four bits
	mov	m,a		; and save that one
	inx	h		; increment the pointer
	mvi	m,$ff	; set the terminator

	sta	sanity

	lxi	h,cksum		; load that one
	lxi	d,dsplrx+6	; set to error location
	call	outdsp		; load the message

	lxi	h,er0msg	; show checksum error
	call	outstr		; on terminal

	lda	cksum		; show the value needed...
	call	outhex
	lda	cksum+1
	call	outhex

	
b40:	lxi	h,vdelay
b50:	sta	sanity
	djnz	b50
	dcx	h
	mov	a,h
	ora	l
	jrnz	b50	

;	set some initial values for the display, etc.

linit:	sta	sanity

	mvi	a,41h		; turn all off
	sta	stb
	sta	istb
	mvi	a,-1
	sta	mkspq
	mvi	a,6ch
	sta	bpq
	sta	ibpq

	lxi	h,1		; set the oscillator values low
	shld	spshl
	shld	spbpl
	shld	bpl
	shld	lpl

	mvi	a,1
	sta	mkshl
	sta	mkbpl

	ret


;	rinit will initialize the regen serial port DART channels
;	the actual initialization comes when a change is seen in the
;	switch...

rinit:	call	tsetup
	call	rsetup

;	and set to 1200 bps speed

	lxi	h,r150		; select the rate

	mvi	a,br0mdw	; set up the nmi counter
	out	brgctl		; store at the control address
	mov	a,l		; load the low byte
	out	brg0
	mov	a,h		; now the high byte
	out	brg0

	mvi	a,br1mdw	; set up the nmi counter
	out	brgctl		; store at the control address
	mov	a,l		; load the low byte
	out	brg1
	mov	a,h		; now the high byte
	out	brg1

	ret


;	routine for the serial regen port.

;	tsetup will take the values stored in the tx_def area
;	and load them into the dart.

tsetup:	lxi	x,tx_def	; set a pointer in ix
	mvi	c,txstat	; load the output port value
	jmpr	tentry		; jump to the routine

rsetup:	lxi	x,rx_def	; set the pointer
	mvi	c,rxstat	; and the output port

tentry:	mvi	a,preset	; set the preset value
	outp	a

	mvi	a,reg4		; set to register
	outp	a		; select that reg
	mov	a,4(x)		; load the clock/stop/parity bits
	outp	a		; set them

	mvi	a,reg5		; set reg 5
	outp	a		; done with that	
	mov	a,5(x)		; read dtr/txlen/txen/rts
	outp	a		; and output

	mvi	a,reg3		; set reg 3
	outp	a
	mov	a,3(x)		; read rxlen/auto/rxen
	outp	a		; set those

	mov	a,c		; see if port 0 or 1
	bit	1,a		; intr vector only in channel b
	jrz	c10		; 0 means port a

	mvi	a,reg2		; select reg2
	outp	a
	mov	a,2(x)		; read interrupt vector
	outp	a		; and set that

c10:	mvi	a,reg1+eires	; set register 1
	outp	a
	mov	a,1(x)		; read intr condx/status affects/tx int/ext int
	outp	a

	mvi	a,10		; reset any external interrupt pending
	outp	a		; done in wr0

	ret			; done....
;	.page
$subtitle(control port setup)

;	routines to setup the control port

csetup:	mvi	a,force		; load the force command mode
	out	costat		; output to 8251
	xthl
	xthl			; wait a bit
	out	costat		; and do it again
	xthl
	xthl
	mvi	a,reset		; reset mode
	out	costat
	xthl
	xthl
	mvi	a,comdw		; load the mode word
	out	costat		; and set that
	xthl
	xthl
	mvi	a,txrxen	; now all on
	out	costat
	xthl
	xthl
	ret			; done....

;	init the console port parameters

cinit:	call	csetup		; setup the usart

	lxi	h,cmdbuf	; set the buffer pointer to input
	shld	cmdptr
	shld	cmdsav

	lxi	h,0		; clear input/output pointer
	shld	ciptr

	ret			; and exit
;	.page
$subtitle(utilities - outdsp, outstr, outch, outnr)

;	outdsp will output string of chars to the display
;	using the internal display codes...
;	if the msb is set in the char, the period for
;	that digit will also be turned on.

outd0:	lxi	d,dsplrx

;	call with the string pointer in hl, and the destination
;	in de.  will output until a -1 byte terminator

outdsp:	mov	a,m		; read the char
	cpi	$ff	; see if at the end
	rz			; exit if we are

	inx	h		; increment the pointer
	push	h		; save that pointer

	mov	b,a		; save the char
	ani	1fh		; 32 max chars now

	lxi	h,dtab		; load the table
	add	l		; add the offset
	mov	l,a
	jrnc	d10		; test for cy
	inr	h		; if cy set, increment the high byte
d10:	mov	a,m		; read the char

	bit	7,b		; see if period is set
	jrz	d20		; if not, skip
	inr	a		; else turn on the period
d20:	stax	d		; store the char in the buffer
	inx	d		; and increment the pointer

	pop	h		; recover hl
	jmpr	outdsp		; and output


;	fill the display with the value stored in acc

displd:	lxi	h,dsplrx	; point to the display reg
	mvi	b,12		; set the length
e10:	mov	m,a		; store it
	inx	h		; increment the pointer
	djnz	e10		; and loop
	ret			; then exit


;	utility for forcing lower case alpha to upper case
;	before the atob conversion process

upper:	ani	7fh		; save only low bits

	cpi	'a'		; see if less than 'a
	rc			; exit if it is

	cpi	'z'+1		; see if greater than 'z
	rnc			; exit if greater than

	res	5,a		; clear a bit in acc
	ret			; for upper case....


;	console processing routines...

;	codin waits for a keypress to arrive, and returns with the
;	upper case key in ACC.  If not cr or sp or 0-9 or A-Z
;	return with CYequ1 else CYequ0

codin:	sta	sanity		; keep the timer going

	in	costat		; look for any chars
	ani	2		; test the bit for rxrdy
	jrz	codin		; wait til ready

	in	codata		; read the char
	call	upper		; make it upper case char

	cpi	lf		;rd  check for line feed character
	jrz	codin		;rd  ignore line feed character

	cpi	'0'		; see if alpha
	rnc			; and exit with cy clear

	cpi	cr		; take a cr
	rz
	cpi	20h		; and space
	rz

	stc			; set the error flag
	ret			; and exit

;rd    	hexp takes the contents of the acc and sends 2 ascii 
;rd	characters to the serial consol port

hexp:	mov	c,a		;rd  save the original character in c
	rlc			;rd
	rlc			;rd  send upper 4 bits 1st
	rlc			;rd
	rlc			;rd
	ani	0fh		;rd  zero upper 4 bits 
	call	outhex		;rd  convert to ascii and send it

	mov 	a,c		;rd  get original character
	ani	0fh		;rd  zero upper 4 bits
	call	outhex		;rd  convert to ascii and send it
	ret			;rd  return


;	outchr takes the contents of acc and sends it to the serial
;	console port.

crlf:	mvi	a,cr
	call	outchr
	mvi	a,lf
	call	outchr
	ret

outhex:	adi	'0'		; make it hex
	cpi	'9'+1		; greater than 9?
	jrc	outchr

	adi	'A'-'0'-10	; add the offset to make it upper ascii
	jmpr	outchr

outnr:	adi	'0'		; make it ascii

outchr:	push	psw		; save the char
f20:	sta	sanity

	in	costat		; read the status
	rrc			; test the tx ready bit
	jrnc	f20		; so loop til ok

f10:	pop	psw		; recover the char
	out	codata		; and send the char
	ret			; then return


;	outstr will send a string to the console port.  All other
;	processing stops until the string has been sent..

;	call with the string in hl

outstr:	mov	a,m		; read the next character...
	ana	a		; -1 says this is the end of the string
	rm			; did we find the last char?

	push	psw

g10:	sta	sanity		; keep the timer going

	in	costat		; wait for tx to be ready
	rrc
	jrnc	g10		; nc says not ready yet

	pop	psw		; recover the char
	out	codata		; and output it

	inx	h		; increment the pointer
	jmpr	outstr		; and loop


;	.page
$subtitle(stack test)

;	test the first 64 ram location to see if they can be written and
;	read.  If ok, then continue, else show a message because we cannot
;	get back...

er1msg:	db	'\r\n\n'
	db	'>>>  CANNOT WRITE STACK! - Fatal Error...'
	db	'\r\n'
	db	'     U13, U24'
	db	$ff

stktst:	sta	sanity		; keep it going

	lxi	h,start		; load with real data
	lxi	d,ram
	lxi	b,64		; test the first 64
	ldir			; move in the data

	lxi	h,start		; now do the test
	lxi	d,ram		; get the destination
	mvi	b,64		; set the length

h10:	sta	sanity
	ldax	d		; read a byte
	cmp	m		; look for a match
	jrnz	h20		; show the error!

	inx	d		; incr the pointers
	inx	h
	djnz	h10		; and loop for 64 bytes

	jmp	sta0		; and continue - it is ok!


h20:	sta	sanity		; keep it going...

;	routines to setup the control port

	mvi	a,force		; load the force command mode
	out	costat		; output to 8251
	xthl
	xthl			; wait a bit
	out	costat		; and do it again
	xthl
	xthl
	mvi	a,reset		; reset mode
	out	costat
	xthl
	xthl
	mvi	a,comdw		; load the mode word
	out	costat		; and set that
	xthl
	xthl
	mvi	a,txrxen	; now all on
	out	costat
	xthl
	xthl

	lxi	h,er1msg	; show the stack error message

h30:	sta	sanity

	in	costat		; wait for ready
	rrc			; test the ready bit
	jrnc	h30

	mov	a,m		; read a char
	inx	h
	cpi	$ff	; see if we are done
	jz	h40		; if so, just exit and loop

	out	codata		; send the char
	jmpr	h30		; and loop

h40:	sta	sanity		; keep it going
	jmpr	h40


;	.page
$subtitle(start and main)

;	init the counters and turn on the nmi timer after that is
;	done...

cimsg:	db	'\r\n\n\n'
	db	'****  HAL ST-8000 TESTS  V1.1  9/5/86  ****'
	db	'\r\n'
;	db	$ff

;	show a help message for the user

mhelp:	db	'\r\n'
	db	'  1 .. RAM Test\r\n'
	db	'  2 .. Display Test\r\n'
	db	'  3 .. Control Bit Test\r\n'
	db	'  4 .. Switch Test\r\n'
	db	'  5 .. Oscillator Tests\r\n'
	db	'  6 .. Terminal Port Regen Test\r\n'
	db	'  7 .. Modem Port Regen Test\r\n'
	db	'  8 .. Timeout Timer Test\r\n'
	db	'  9 .. Battery RAM Test\r\n\n'
	db	'  D .. Debug Options\r\n'		;rd debug options
	db	$ff

prompt:	db	'\r\n'
	db	'At Your Command >> '
	db	$ff


;	here is where it all begins...

start:	sta	sanity
	jmp	stktst		; test for valid stack area....

sta0:	call	nminit		; init the nmi stuff
	call	cinit		; init the  command port
	call	rinit		; init the regen stuff
	call	linit		; init the latches to all off

	call	battst		; see if coming from battery test
	call	timtst		; see if coming from timer test

	call	init		; init the machine

rexit:	lxi	sp,stack	; reset the stack

	lxi	h,cimsg		; show the start
	call	outstr

mnmsg:	lxi	h,prompt	; show the prompt message
	call	outstr		; do it
	
main:	sta	sanity

	call	codin		; see if any chars holding

	cpi	cr
	jrz	mnmsg

	lxi	h,rexit		; exit to the help prompt
	push	h		; save that

	cpi	'1'		; ram test
	jz	ramtest

	cpi	'2'		; display test
	jz	display

	cpi	'3'		; output bit test
	jz	ctrlbit

	cpi	'4'		; switch test
	jz	swtest

	cpi	'5'		; oscillator test
	jz	otest

	cpi	'6'		; regeneration ckt test
	jz	regtest

	cpi	'7'		; modem regen test
	jz	mrgtest

	cpi	'8'		; timer test
	jz	timer

	cpi	'9'		; battery ram test
	jz	battery

	cpi	'D'		;rd check for debug 
	jz	debug		;rd goto debug options

;	cpi	'Q'
;	jz	qlatch

	cpi	'H'
	rz

	pop	h

	mvi	a,07h
	call	outchr

	jmp	main

;	.page
$subtitle(terminal port regeneration test)

;	look to see if the regen ckt can send and receive
;	a char using the interrupt.  Assumes that the jumper
;	plug has been installed in the unit to connect the 
;	receive data to send data input...

rgmsg:	db	'\r\n\n'
	db	'>>  Terminal Regeneration Test.    IC: U36, U49, U50'
	db	'\r\n'
	db	'    Install jumpers between J9-2&3 and J10-2&7, then Press CR.'
	db	'\r\n'
	db $ff

regm0:	db	'\r\n'
	db	'>>  TIME OUT - No data received'
	db	$ff

regm1:	db	'\r\n'
	db	'>>  Test Passes...'
	db	$ff

regm2:	db	'\r\n'
	db	'>>  TEST FAILS!'
	db	$ff

regm3:	db	'\r\n'
	db	'>>  OUTPUT CHANNEL NOT READY'
	db	$ff

regm4:	db	'\r\n'
	db	'    Press SPACE to test again,  CR to EXIT'
	db	$ff

regtest:
	lxi	h,rgmsg
	call	outstr

	call	rinit		; set up the ports

	lda	ibpq		; set to regen mode
	ani	0f7h		; clear a bit
	sta	bpq		; set to regen mode

	lda	istb		; force the printer on
	ori	80h		; set to 1
	sta	stb		; and set the output

	call	codin		; wait for keypress

rgst:	in	txstat		; read the status

	in	txdata		; clear any holding data
	in	txdata
	in	txdata

	im2			; set the mode
	ei			; and enable

	mvi	b,5		; do 10 chars...

lpst:	sta	sanity		; keep it running
	in	txstat		; look for tx ready
	ani	txrdy		; test for ready to transmit
	jz	txnrdy

	mvi	a,$ff	; clear the result reg
	sta	txdsav		; so we can get it

	mvi	a,55h		; send a char
	out	txdata		; send it

	lxi	h,$ff	; wait a while
i10:	sta	sanity		; keep the timer going
	lda	txdsav		; look for a char
	cpi	$ff	; if -1, none arrived yet
	jnz	i20		; if comes, grab it

	dcx	h		; wait
	mov	a,h
	ora	l
	jrnz	i10

	lxi	h,regm0		; timeout failure
	jmpr	regex

i20:	cpi	55h		; see if same char
	lxi	h,regm1		; received char ok
	jrz	regex
	lxi	h,regm2		; error in received char
regex:	call	outstr

	djnz	lpst		; loop for several times


	di

	lxi	h,regm4		; CR to exit space to repeat
	call	outstr
	call	codin
	cpi	cr
	jnz	rgst

	call	linit

	jmp	rexit


txnrdy:	lxi	h,regm3		; output reg not ready
	jmpr	regex	


;	.page
$subtitle(modem port regeneration test)

;	look to see if the regen ckt can send and receive
;	a char using the interrupt.  Assumes that the jumper
;	plug has been installed in the unit to connect the 
;	receive data to send data input...

mrgmsg:	db	'\r\n\n'
	db	'>>  Modem Regeneration Test.    IC: U36, U49, U50'
	db	'\r\n'
	db	'    Jumper audio out to audio in, then Press CR.'
	db	'\r\n'
	db 	$ff

mrgtest:
	lxi	h,mrgmsg
	call	outstr

	call	rinit		; set up the ports

	lda	istb		; set to m/s detect mode
	ori	34h		; and turn on the tx bit
	sta	stb

	mvi	a,00h		; set the q's
	sta	mkspq

	lxi	h,8b9fh		; set the space to 3000
	shld	spshl		; store that

	mvi	a,low 2125	; set mark to 1000hz
	sta	mkshl		; done..	

	lxi	h,8b9fh		; set the space to 3000
	shld	spbpl

	mvi	a,low 2125	; set the mark filter center
	sta	mkbpl		; done.

	lxi	h,22032		; set the bandpass
	shld	bpl		; done...

	lxi	h,3072		; set for 150 hz low pass
	shld	lpl

	lda	ibpq		; set to regen mode
	ani	0f3h		; set to regen, normal
	ori	13h		; set to wide input
	sta	bpq		; set to regen mode

	call	codin		; wait for keypress

mrgst:	in	rxstat		; read the status
	in	txstat

	in	rxdata		; clear any holding data
	in	rxdata
	in	rxdata

	im2			; set the mode
	ei			; and enable

	mvi	b,5		; do 10 chars...

mlpst:	sta	sanity
	in	rxstat		; look for tx ready
	ani	txrdy		; test for ready to transmit
	jz	rxnrdy

	mvi	a,$ff	; clear the result reg
	sta	rxdsav		; so we can get it

	mvi	a,55h		; send a char
	out	rxdata		; send it

	lxi	h,$ff	; wait a while
j10:	sta	sanity		; keep the timer going
	lda	rxdsav		; look for a char
	cpi	$ff	; if -1, none arrived yet
	jnz	j20		; if comes, grab it

	dcx	h		; wait
	mov	a,h
	ora	l
	jrnz	j10

	lxi	h,regm0		; timeout failure
	jmpr	mregex

j20:	cpi	55h		; see if same char
	lxi	h,regm1		; received char ok
	jrz	mregex
	lxi	h,regm2		; error in received char
mregex:	call	outstr

	djnz	mlpst		; loop for several times


	di

	lxi	h,regm4		; CR to exit space to repeat
	call	outstr
	call	codin
	cpi	cr
	jnz	mrgst

	call	linit		; init the latches
	jmp	rexit

rxnrdy:	lxi	h,regm3		; output reg not ready
	jmpr	mregex	


;	.page
$subtitle(oscillator tests)

;	otest will take the user thru all of the internal synthesizers...
;	must choose which to test then will get the value

otmsg:	db	'\r\n\n'
	db	'>>  Oscillator Tests:  Choose a Test,  CR to EXIT\r\n'
	db	'      1 - Band Pass\r\n'
	db	'      2 - MARK Filter\r\n'
	db	'      3 - SPACE Filter\r\n'
	db	'      4 - Low Pass Filter\r\n'
	db	'      5 - Transmit Tones\r\n'
	db	'    Select Oscillator >> '
	db	$ff

otest:	lxi	h,otmsg
	call	outstr

k10:	call	codin		; wait for keypress
	cpi	cr		; exit on cr
	jnz	k20

	call	linit		; clear all latches

	jmp	rexit		; and show the intro message

k20:	sui	'1'		; take off the offset
	jz	otbp
	dcr	a
	jz	otmrk
	dcr	a
	jz	otspa
	dcr	a
	jz	otlp
	dcr	a
	jz	otxmt

	mvi	a,7h		; send an error indication
	call	outchr

	jmp	k10


;	test the bandpass filter freq

otbmsg:	db	'\r\n\n'
	db	'>>  Band Pass Filter Test.  Measure: U56-12\r\n'
	db	'    IC: U4, U56, U57, U58, U59, U60, U61, U62, U63\r\n'
	db	'    Press SPACE to cycle, CR to EXIT\r\n'
	db	$ff
otbhi:	db	'\r\n'
	db	' -- BP Frequency = 68263 Hz'
	db	$ff
otblo:	db	'\r\n'
	db	' -- BP Frequency = 34132 Hz'
	db	$ff

otbp:	lxi	h,otbmsg
	call	outstr	

l10:	lxi	h,02aaah	; load the frequency
	shld	bpl

	lxi	h,otbhi
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	lxi	h,01555h
	shld	bpl

	lxi	h,otblo
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	jmpr	l10		


;	test the mark bandpass filter freq

otmmsg:	db	'\r\n\n'
	db	'>>  MARK Filter Test.  Measure: U43-12\r\n'
	db	'    IC: U3, U19, U21, U33, U34, U35, U43, U44, U55\r\n'
	db	'    Press SPACE to cycle, CR to EXIT\r\n'
	db	$ff
otmhi:	db	'\r\n'
	db	' -- MARK Filter Frequency = 136500 Hz'
	db	$ff
otmlo:	db	'\r\n'
	db	' -- MARK Filter Frequency = 68250 Hz'
	db	$ff

otmrk:	lxi	h,otmmsg
	call	outstr	

m10:	lxi	h,2730		; load the frequency
	mov	a,l
	sta	mkbpl	 	; low byte is ok
	mov	a,h		; high byte is shared with space
	rlc
	rlc
	rlc
	rlc
	sta	spbph

	lxi	h,otmhi
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	lxi	h,1365
	mov	a,l
	sta	mkbpl	 	; low byte is ok
	mov	a,h		; high byte is shared with space
	rlc
	rlc
	rlc
	rlc
	sta	spbph

	lxi	h,otmlo
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	jmpr	m10		



;	test the mark bandpass filter freq

otsmsg:	db	'\r\n\n'
	db	'>>  SPACE Filter Test.  Measure: U41-12\r\n'
	db	'    IC: U3, U19, U20, U30, U31, U41, U42, U55\r\n'
	db	'    Press SPACE to cycle, CR to EXIT\r\n'
	db	$ff
otshi:	db	'\r\n'
	db	' -- SPACE Filter Frequency = 136500 Hz'
	db	$ff
otslo:	db	'r\n'
	db	' -- SPACE Filter Frequency = 68250 Hz'
	db	$ff

otspa:	lxi	h,otsmsg
	call	outstr	

n10:	lxi	h,2730		; load the frequency
	shld	spbpl

	lxi	h,otshi
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	lxi	h,1365
	shld	spbpl

	lxi	h,otslo
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	jmpr	n10		

;	test the lowpass filter freq

otlmsg:	db	'\r\n\n'
	db	'>>  LOWPASS Test.  Measure: U48-15\r\n'
	db	'    IC: U4, U5, U6, U7, U8, U45, U46, U47, U48\r\n'
	db	'    Press SPACE to cycle, CR to EXIT\r\n'
	db	$ff
otlhi:	db	'\r\n'
	db	' -- LOWPASS Frequency = 68263 Hz'
	db	$ff
otllo:	db	'\r\n'
	db	' -- LOWPASS Frequency = 34132 Hz'
	db	$ff

otlp:	lxi	h,otlmsg
	call	outstr	

o10:	lxi	h,02aaah	; load the frequency
	shld	lpl

	lxi	h,otlhi
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	lxi	h,01555h
	shld	lpl

	lxi	h,otllo
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	jmpr	o10		






;	test the tx osc

otxmsg:	db	'\r\n\n'
	db	'>>  Transmit Tone Test.  Measure:  U54-9\r\n'
	db	'    IC: U3, U15, U16, U17, U27, U28, U29, U36, U38, U39, U40\r\n'
	db	'        U52, U53, U54, U55\r\n'
	db	'    Press SPACE to cycle, CR to EXIT\r\n'
	db	$ff

otmkhi:	db	'\r\n'
	db	' -- TX Frequency = 27300 Hz  (MARK tone)'
	db	$ff
otmklo:	db	'\r\n'
	db	' -- TX Frequency = 13650 Hz  (MARK tone)'
	db	$ff

otsphi:	db	'\r\n'
	db	' -- TX Frequency = 27300 Hz  (SPACE tone)'
	db	$ff
otsplo:	db	'\r\n'
	db	' -- TX Frequency = 13650 Hz  (SPACE tone)'
	db	$ff

otxmt:	lxi	h,otxmsg
	call	outstr

	call	rinit		; set up the ports

	lda	ibpq		; load the current setting
	ani	0f7h		; set to regen mode
	sta	bpq		; done...

;	first test the mark holding regs...

mkttt:	in	rxstat		; set to reg 0

	mvi	a,5		; set to break mode to enable the mark
	out	rxstat
	mvi	a,0fah		; now set the break
	out	rxstat

	mvi	a,high 2730	; load high byte of high rate
	rlc
	rlc
	rlc
	rlc
	sta	spshh		; set the upper byte

	mvi	a,low 2730	; now the low byte
	sta	mkshl		; set the mark low

	lxi	h,otmkhi
	call	outstr

	call	codin
	cpi	cr
	jz	otxex

	mvi	a,high 1365	; load high byte of high rate
	rlc
	rlc
	rlc
	rlc
	sta	spshh		; set the upper byte

	mvi	a,low 1365	; now the low byte
	sta	mkshl		; set the mark low

	lxi	h,otmklo
	call	outstr

	call	codin
	cpi	cr
	jz	otxex

	in	rxstat		; clear to reg 0
	mvi	a,5
	out	rxstat		; point to reg 5
	mvi	a,0eah		; turn on the break signal
	out	rxstat		; do  it

spttt:	lxi	h,2730 		; load high byte of high rate
	shld	spshl

	lxi	h,otsphi
	call	outstr

	call	codin
	cpi	cr
	jz	otest

	lxi	h,1365		; now the low rate
	shld	spshl

	lxi	h,otsplo
	call	outstr

	call	codin
	cpi	cr
	jz	otxex

	jmp	mkttt		


otxex:	in	rxstat		; clear to reg 0
	mvi	a,5
	out	rxstat
	mvi	a,0eah
	out	rxstat		; turn off the break

	jmp	otest

;	.page
$subtitle(ram test)

;	ram test will load a pattern in the memory and test for the
;	pattern after the intial write is done...
;	All memory is trashed...

ramsg:	db	'\r\n\n'
	db	'>>  RAM Test...  U13   '
	db	$ff
raok:	db	'OK!'
	db	$ff
rang:	db	'RAM ERRORS - Replace it.'
	db	$ff

ramtest:
	lxi	h,ramsg
	call	outstr

	mvi	a,chsp
	call	displd
	
	xra	a		; turn off the display
	out	nmiena

;rd	lxi	d,ram		; set to the beginning
;rd	lxi	h,rom		; and load the start of the rom prog
;rd	lxi	b,800h		; load the ram length
;rd	ldir			; load the memory

;rd	sta	sanity

;rd	lxi	d,ram		; now check
;rd	lxi	h,rom
;rd	lxi	b,800h
;rd10$:	ldax	d		; read one
;rd	cmp	m		; test
;rd	jrnz	20$

;rd	inx	h		; increment the pointers
;rd	inx	d
;rd	dcx	b		; dec the length
;rd	mov	a,b
;rd	ora	c		; test for the end
;rd	jrnz	10$

;rd	lxi	h,raok
;rd	jmpr	30$


	lxi	h,ram		;rd  load hl with memort pointer
	mvi	b,ramend	;rd  load b with ram length
	mvi	c,3		;rd  load c with pattern count
	mvi	d,0		;rd  load d with 1st pattern

p1:	mov	m,d		;rd  write pattern to ram
	sta	sanity		;rd  reset sanity timer
	inx	h		;rd  increment memory pointer
	mov	a,h		;rd
	cmp	b		;rd  check for end of ram
	jrnz	p1		;rd  if not write another location

	lxi	h,ram		;rd  reset memory pointer
p2:	mov	a,m		;rd  read memory
	sta	sanity		;rd  reset sanity timer
	cmp	d		;rd  compare with pattern written
	jnz	mfail		;rd  report failure if not the same

	inx	h		;rd  increment memory pointer
	mov	a,h		;rd
	cmp	b		;rd  check for end of ram
	jrnz	p2		;rd  if not read another location

	lxi	h,ram		;rd  reset memory pointer
	dcr	c		;rd  decrement pattern counter
	jrz	minc		;rd  goto incrmenting pattern test on 0

	mov	a,c		;rd  get pattern count
	cpi	1		;rd  see what pattern is next
	jrnz	p3		;rd

	mvi	d,$ff		;rd  set for all 1's pattern
	jmp	p1		;rd  run test with all 1's as the pattern

p3:	mvi	a,55h		;rd  set for alternating 0101 pattern
	jmp	p1		;rd  run test with alt as the pattern

minc:	mvi	d,0		;rd  set pattern to 0 to start
q1:	mov	m,d		;rd  write memory
	sta	sanity		;rd  reset sanity timer
	
	inr	d		;rd  increment pattern
	mov	a,d		;rd  get pattern
	cpi	0feh		;rd  check for end of pattern
	jrnz	q2		;rd
	mvi	d,0		;rd  reset pattern
q2:	inx	h		;rd  increment memory pointer
	mov	a,h		;rd  get h part of address
	cmp	b		;rd  check for end of ram
	jrnz	q1		;rd  if not write another location

	lxi	h,ram		;rd  reset memory pointer
	mvi	d,0		;rd  reset pattern
q3:	mov	a,m		;rd  read memory
	sta	sanity		;rd  reset sanity timer
	cmp	d		;rd  check against what was written
	jnz	mfail		;rd  report failure if not the same

	inr	d		;rd  increment the pattern
	mov	a,d		;rd
	cpi	0feh		;rd  check for the end of the pattern
	jrnz	q4		;rd
	mvi	d,0		;rd  reset pattern
q4:	inx	h		;rd  increment memory pointer
	mov	a,h		;rd
	cmp	b		;rd  check for the end of ram
	jrnz	q3		;rd  if not read another memory location
	
	lxi	h,raok		;rd  load hl with ram ok pointer
	jmpr	mf1		;rd  print ram ok

mfail:	lxi	h,rang		;rd  load hl with ram failed pointer
mf1:	call	outstr

	mvi	a,cdsh
	call	displd

	mvi	a,1
	out	nmiena
	
	jmp	rexit

;	.page
$subtitle(display test)

;	display - test the display digits by rotating a bar thru the
;	display output...  leave with all turned off

dsmsg:	db	'\r\n\n'
	db	'>>  Display Test - Press SPACE to cycle,  CR to EXIT\r\n'
	db	'    IC: U4   '
	db	$ff

dsplst:	db	0feh,00h,01h,02h,04h,08h,10h,20h,40h,80h
	db	$ff,0feh,0fdh,0fbh,0f7h,0efh,0dfh,0bfh,07fh

display:
	lxi	h,dsmsg
	call	outstr

	mvi	a,$ff		; turn all of them on
	call	displd

	call	codin		; wait a bit
	cpi	cr
	jz	dsplex

	mvi	a,00h
	call	displd

	lxi	h,dsplrx
	mvi	b,12

r5:	mvi	m,$ff		; output one char

	call	codin
	cpi	cr
	jz	dsplex

	mvi	m,0h		; clear the last one

	inx	h
	djnz	r5

	jmpr	r20		; jump in at beginning

r10:	shld	temp		; save the pointer
	mov	a,m		; read the new state
	call	displd		; and clear the output

	call	codin		; wait for a keypress
	cpi	cr		; see if we are done
	jrz	dsplex		; and exit if cr received

	lhld	temp		; read the pointer
	inx	h		; increment it
	mov	a,l		; and look for the end
	cpi	low display	; see if we are done
	jrnz	r10		; if not, store this on
r20:	lxi	h,dsplst	; reset to the beginning
	jmpr	r10		; and loop

dsplex:	mvi	a,cdsh		; set the display to all dashes
	call	displd
	jmp	rexit

;	.page
$subtitle(Q Latch test)

	%if	xxx	eq	1		; delete for now

;	qlatch - cycle the bits in the q register to check for
;	any shorts or opens.  go from lsb to msb on mark then
;	space

qmsg:	db	'\r\n\n'
	db	'>>  Q Latch Test.  Press SPACE to cycle, CR to EXIT'
	db	$ff

qllst:	db	$ff,0feh,0fdh,0fbh,0f7h
	db	$ff
	db	0efh,0dfh,0bfh,07fh
	db	$ff,$ff,$ff
	db	00h,01h,02h,04h,08h
	db	00h
	db	10h,20h,40h,80h
	db	00h,00h,00h

qhlst:	db	63h,63h,63h,63h,63h
	db	23h
	db	63h,63h,63h,63h
	db	43h,62h,61h
	db	00h,00h,00h,00h,00h
	db	40h
	db	00h,00h,00h,00h
	db	20h,02h,01h

qlatch:	lxi	h,qmsg
	call	outstr
	jmpr	s40

s10:	shld	temp
	mov	a,m		; read the new flag
	sta	mkspq		; set the flags

	mvi	a,qhlst-qllst
	add	l
	mov	l,a
	jrnc	s20
	inr	h

s20:	lda	ibpq
	ani	9ch
	ora	m
	xri	3		; flip two low bits
	sta	ibpq
	sta	bpq

	call	codin		; now, wait for a char
	cpi	cr
	jz	s50

	lhld	temp		; read the pointer
	inx	h		; and increment it
	mov	a,l		; look for the end
	cpi	low qhlst
	jrnz	s10		; and loop if not at the end

s40:	lxi	h,qllst		; set to the beginning
	jmpr	s10		; and loop

s50:	lda	ibpq		; set to all off
	ori	60h
	ani	0fch
	sta	ibpq
	sta	bpq
	mvi	a,$ff
	sta	mkspq

	jmp	rexit

	%endif
	

;	.page
$subtitle(control bits)

;	routine to cycle thru all of the control bits on the
;	interface.  Will start with all bits turned off
;	then selectively turn on each one to lite the lite on
;	the front panel...

ctrmsg:	db	'\r\n\n'
	db	'>>  Control Bit Test.  Press SPACE to cycle,'
	db	'  CR to EXIT\r\n'
	db	'    IC:  U1, U18, U22\r\n'
	db	$ff

;ctrlm0:	db	'CTS     U1-2 '
;ctrlm1:	db	'PTT RX  U1-6 '
;	db	'PTT TX  U1-15'
;	db	'ANTISP  U1-19'
;	db	'DETA    U1-5 '
;	db	'DETB    U1-9 '
;	db	'FM      U1-12'
;	db	'SELCAL  U1-16'
;	db	'QM0    U18-9 '
;	db	'QM1    U18-5 '
;	db	'QM2    U18-16'
;	db	'QM3    U18-12'
;	db	'QS0    U18-6 '
;	db	'QS1    U18-2 '
;	db	'QS2    U18-19'
;	db	'QS3    U18-15'
;	db	'QIA    U22-9 '
;	db	'QIB    U22-5 '
;	db	'NORM   U22-16'
;	db	'CRT    U22-12'
;	db	'QS3    U22-2 '
;	db	'QM3    U22-19'

ctrlm0:	db	'QM3      U22-19'
ctrlm1:	db	'QM3      U18-12'
	db	'QM2      U18-16'
	db	'QM1      U18-5 '
	db	'QM0      U18-9 '
	db	'QIB      U22-5 '
	db	'QIA      U22-9 '
	db	'FM       U1-12 '
	db	'NORM     U22-16'
	db	'DETB     U1-9  '
	db	'DETA     U1-5  '
	db	'ANTISP   U1-19 '
	db	'CTS      U1-2  '
	db	'QS0      U18-6 '
	db	'QS1      U18-2 '
	db	'QS2      U18-19'
	db	'QS3      U18-15'
	db	'QS3      U22-2 '
	db	'PTT TX   U1-15 '
	db	'PTT RX   U1-6  '
	db	'CRT      U22-6 '
	db	'SELCAL   U1-16 '

	
;ctrlst:	db	01h,02h,04h,08h,10h,20h,40h,80h
;ctrl1:	db	01h,02h,04h,10h,20h,40h

;rd
ctrlst:	db	2ch,0f7h,0fbh,0fdh,0feh,6eh,6dh,01h,68h,61h,51h,49h,40h
	db	0efh,0dfh,0bfh,7fh,4ch,45h,43h,7ch,0c1h

ctrlbit:
	lxi	h,ctrmsg
	call	outstr

	mvi	a,41h		; turn all off
	sta	stb
	mvi	a,-1
	sta	mkspq
	mvi	a,6ch
	sta	bpq

	call	codin
	cpi	cr
	jz	ctrlex

;	first stb

t5:	lxi	h,ctrlm0	; set initial message pointer
	shld	temp

	lxi	h,ctrlst	; point to the beginning


;	mvi	b,8		; do eight words for this one

;10$:	mov	a,m		; read it
;	xri	41h		; flip cts and fm bits
;	inx	h		; increment pointer
;	sta	stb

;	call	bitmsg
	
;	call	codin		; wait for keypress
;	cpi	cr		; if cr, exit
;	jz	ctrlex

;	djnz	10$

;	mvi	a,41h
;	sta	stb

;	now mkspq

;	lxi	h,ctrlst	; point to the beginning
;	mvi	b,8		; do nine words for this one

;20$:	mov	a,m		; read it
;	cma			; need to flip them
;	inx	h		; increment pointer
;	sta	mkspq

;	call	bitmsg

;	call	codin		; wait for keypress
;	cpi	cr		; if cr, exit
;	jz	ctrlex

;	djnz	20$

;	mvi	a,-1
;	sta	mkspq

;	now bpq

;	lxi	h,ctrl1		; point to the beginning
;	mvi	b,6		; do nine words for this one
;
;30$:	mov	a,m		; read it
;	xri	6ch
;	inx	h		; increment pointer
;	sta	bpq
;
;	call	bitmsg

;	call	codin		; wait for keypress
;	cpi	cr		; if cr, exit
;	jz	ctrlex

;	djnz	30$

;	mvi	a,6ch
;	sta	bpq

;	jmpr	5$

ctl0:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment pointer
	sta	bpq		;rd  turn on QM3  u22-19
	lxi	x,ctl1		;rd  point to next bit

step:	call	bitmsg		;rd  print bit message
	call	codin		;rd  get key press
	cpi	cr
	jz	ctrlex		;rd  exit on cr
	
	mvi	a,41h		
	sta	stb		;rd  zero stb latch
	mvi	a,-1
	sta	mkspq		;rd  zero mkspq latch
	mvi	a,6ch	
	sta	bpq		;rd  zero bpq latch
	pcix			;rd  goto set next bit

ctl1:	mvi	b,4		;rd  set number of mkspq bits to set
	lxi	x,ctl2		;rd  point to next bit sequence

ctl2:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pointer	
	sta	mkspq		;rd  turn on QM3 - QM0 of u18
	dcr	b		;rd  decrement repetition counter
	jnz	step		;rd  do all 4
	lxi	x,ctl3		;rd  point to next bit sequence
	jmpr	step

ctl3:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pointer
	sta	bpq		;rd  turn on QIB  u22-5
	lxi	x,ctl4		;rd  point to next bit sequence
	jmp	step		

ctl4:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pointer
	sta	bpq		;rd  turn QIA  u22-9
	lxi	x,ctl5		;rd  point to the next bit sequence
	jmp	step

ctl5:	mov	a,b		;rd  get control bit pattern
	inx	h		;rd  increment bit pattern pointer
	sta	stb		;rd  turn on FM  u1-12
	lxi	x,ctl6		;rd  point to next bit sequence
	jmp	step

ctl6:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pattern pointer
	sta	bpq		;rd  turn on NORM  u22-16
	lxi	x,ctl7		;rd  point to next bit sequence
	jmp	step

ctl7:	mvi	b,4		;rd  set number of stb bits ti set
	lxi	x,ctl8		;rd  point to next bit sequence to do

ctl8:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pattern pointer
	sta	stb		;rd  turn on DETB u1-9, DETA u1-5
	dcr	b		;rd  ANTISP u1-19 and CTS u1-2
	jnz	step		
	lxi	x,ctl9		;rd  point to next bit sequence
	jmp	step

ctl9:	mvi	b,4		;rd  set number of mkspq bits to set
	lxi	x,ctl10		;rd  point to next bit sequence
	
ctl10:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment pattern pointer
	sta	mkspq		;rd  turn on QS0 - QS3 of u 18
	dcr	b
	jnz	step
	lxi	x,ctl11		;rd  point to next bit sequence
	jmp	step

ctl11:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pattern pointer
	sta	bpq		;rd  turn on QS3  u22-2
	lxi	x,ctl12		;rd  point to next bit sequence
	jmp	step

ctl12:	mov	a,m		;rd  get control bit sequence
	inx	h		;rd  increment bit pattern pointer
	sta	stb		;rd  turn on PTT TX  u1-15
	lxi	x,ctl13		;rd  point to next bit sequence
	jmp	step

ctl13:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pointer
	sta	stb		;rd  turn on PTT RX  u1-6
	lxi	x,ctl14		;rd  point to next bit sequence
	jmp	step

ctl14:	mov	a,m		;rd  get control bit pattern
	inx	h		;rd  increment bit pattern pointer
	sta	bpq		;rd  turn on CRT  u22-12
	lxi	x,ctl15		;rd  point to next bit sequence
	jmp	step	

ctl15:	mov	a,m		;rd  get control bit pattern
	sta	stb		;rd  turn on SELCAL  u1-16

	lxi	h,ctrlm0	;rd  load hl with start of bit message
	shld	temp		;rd  save it in temp for bitmsg routine

	lxi	h,ctrlst	;rd  load hl with start of bit pattern
	lxi	x,ctl0		;rd  point to 1st bit pattern
	jmp	step


ctrlex:	call	linit
	jmp	rexit


;	send a message to the terminal

bitm0:	db	'\r\n'
	db	' -- '
	db	$ff

bitmsg:	push	h	 	; dont disturb hl
	push	b

	lxi	h,bitm0
	call	outstr

	lhld	temp		; get the bit pointer message
	lxi	d,cmdbuf	; load the destination
	lxi	b,ctrlm1-ctrlm0	; and set the fixed length
	ldir			; shift in the message

	mvi	a,$ff	; set the terminator
	stax	d
	shld	temp		; and save the new pointer

	lxi	h,cmdbuf	; set to the beginning
	call	outstr		; and send the message

	pop	b
	pop	h
	ret

;	.page
$subtitle(battery ram test routine)

;	battery ram test routines will load the return flags, then
;	ask the user to cycle the power...  if all goes well, it
;	will tell him that all is working the way that it should

btmsg:	db	'\r\n\n'
	db	'>>  Battery Backup RAM Test...  TURN OFF AC POWER \r\n'
	db	'    IC: U13  '
	db	$ff

battery:
	lxi	h,btmsg		; show the message
	call	outstr

	lxi	h,batret	; load the good return value
	shld	btest		; and store it

	mvi	a,-1
	sta	btflg		; set the flag

u10:	call	codin		; if cr, exit
	cpi	cr
	jrz	bexit
	jmpr	u10


;	if we get here, then the battery backup memory is working

btgmsg:	db	'\r\n\n'
	db	'>>  Battery RAM WORKS!'
	db	$ff

batret:	lxi	h,btgmsg	; show the good message
	call	outstr
	jmp	rexit		; and exit

;	battst will look to see if we did a power off/on batter ram test

battst:	lda	btflg		; see if the flag is set
	inr	a		; will be -1 if set
	jrz	bat0

bexit:	xra	a		; clear the flag
	sta	btflg

	lxi	h,0
	shld	btest		; and the jump address
	ret

bat0:	lhld	btest		; load the jump value
	mov	a,h		; compare it too
	cpi	high batret
	jrnz	bexit

	mov	a,l
	cpi	low batret 
	jrnz	bexit	

	push	h		; save this address
	jmpr	bexit		; will jump on the return


;	.page
$subtitle(timer test)

;	timer  will test the timeout timer
;	will set the return address flag, then go into a wait to see if
;	we get back here or not

ttmsg:	db	'\r\n\n'
	db	'>>  Timeout Timer Test...  Please Wait.\r\n'
	db	'    IC: U69, U70, U71'
	db	$ff

tt1msg:	db	'\r\n'
	db	'>>  TIMEOUT FAILS!'
	db	$ff

timer:	lxi	h,ttmsg
	call	outstr

	mvi	a,$ff
	sta	ttflg
	lxi	h,timret
	shld	ttest

	lxi	h,0
v10:	in	costat		;rd  read console status
	rrc			;rd  check for tx ready
	jrnc	v10		;rd  wait for tx ready

	mvi	a,'.'		;rd  load acc with .
	out	codata		;rd  print .... until timer goes off

	dcx	h
	mov	a,h
	ora	l
	jrnz	v10

	lxi	h,tt1msg		; test fails
	jmpr	timex


;	if we get here, we are ok

tt2msg:	db	'\r\n\n'
	db	'>>  Timeout works...'
	db	$ff

timret:	lxi	h,tt2msg
timex:	call	outstr

	xra	a		; clear the flag
	sta	ttflg
	lxi	h,0
	shld	ttest		; and the jump address

	jmp	rexit


;	test for the timer

timtst:	lda	ttflg		; load the flag
	inr	a		; -1 means enabled
	jrz	w20

w10:	xra	a		; clear the flag
	sta	ttflg
	lxi	h,0
	shld	ttest		; and the jump address
	ret			; and exit

w20:	lhld	ttest		; read the jump address
	mov	a,h		; compare for return
	cpi	high timret
	jrnz	w10

	mov	a,l
	cpi	low timret
	jrnz	w10

	pchl			; jump to the routine




;	.page
$subtitle(scan input switches)

;	swtest - look for changes in the switches, and show the changes on 
;	the terminal when they occur...

tdelay:	push	h		; save hl
	lxi	h,tick		; point to the tick variable
	mov	a,m		; read current tick
	adi	10		; add an offset value
x10:	sta	sanity		; now wait
	cmp	m
	jrnz	x10		; and loop
	pop	h		; recover hl
	ret			; and exit


swmsg:	db	'\r\n\n'
	db	'>>  Switch Test  -  Press CR to EXIT \r\n'
	db	'    IC: U9\r\n'
	db	$ff

swtest:	sta	sanity		; keep the timer going
	call	swinit		; init the memory locations

	lxi	h,swmsg		; show the message
	call	outstr

	call	linit

;	scan the front panel looking for any changes in the switches.
;	if a change is found, change the appropriate variable in memory...

scanin:	sta	sanity
	in	costat		; look for any holding data
	ani	rxrdy		; see if any there...
	jrz	scn0

	in	codata		; look for cr
	call	upper		; mask and make upper case
	cpi	cr		; if not, just exit
	jrnz	scn0		; if equal, exit

	call	linit

	jmp	rexit

;	in0

scn0:	sta	sanity
	lxi	h,iin0		; and load the current valid
	in	in0		; read the switch
	cmp	m		; see if equal last sample
	jrz	scn1		; if equal, do the next one

;	change detected.... add a delay for things to settle

	call	tdelay

	in	in0		; read the sample again
	mov	d,a		; save the new state
	xra	m		; and look for changes
	jrz	scn1		; if none, just continue

	mov	m,d		; update the memory location
	mov	e,a		; and save the changes

	call	prin0		; process that input switch

;	in1

scn1:	sta	sanity
	lxi	h,iin1		; and load the current valid
	in	in1		; read the switch
	cmp	m		; see if equal last sample
	jrz	scn2		; if equal, do the next one

;	change detected.... add a delay for things to settle

	call	tdelay

	in	in1		; read the sample again
	mov	d,a		; save the new state
	xra	m		; and look for changes
	jrz	scn2		; if none, just continue

	mov	m,d		; update the memory location
	mov	e,a		; and save the changes

	call	prin1		; process that input switch

;	in2

scn2:	sta	sanity
	lxi	h,iin2		; and load the current valid
	in	in2		; read the switch
	cmp	m		; see if equal last sample
	jrz	scn3		; if equal, do the next one

;	change detected.... add a delay for things to settle

	call	tdelay

	in	in2		; read the sample again
	mov	d,a		; save the new state
	xra	m		; and look for changes
	jrz	scn3		; if none, just continue

	mov	m,d		; update the memory location
	mov	e,a		; and save the changes

	call	prin2		; process that input switch

;	in3

scn3:	sta	sanity
	lxi	h,iin3		; and load the current valid
	in	in3		; read the switch
	cmp	m		; see if equal last sample
	jrz	scn4		; if equal, do the next one

;	change detected.... add a delay for things to settle

	call	tdelay

	in	in3		; read the sample again
	mov	d,a		; save the new state
	xra	m		; and look for changes
	jrz	scn4		; if none, just continue

	mov	m,d		; update the memory location
	mov	e,a		; and save the changes

	call	prin3		; process that input switch

scn4:	jmp	scanin

;	.page
$subtitle(proc in)

;	change found in input 0
;	process the change..

prin0:	ani	0c0h		; see if change in ptt input
	jrz	y10		; if not, continue

;	process ptt change

	mov	a,d		; get the new state
	cma			; complement the bits
	ani	0c0h		; save only the upper two bits
	rlc			; rotate to the position in istb
	rlc
	rlc
	mov	c,a		; save for a bit
	lda	istb		; get the image of the output
	ani	0f9h		; clear the two bits
	ora	c		; combine the new ptt state
	sta	istb		; put it back
	sta	stb		; and load the latch

	call	dspptt
	
;	see if change in tuner selection

y10:	mov	a,e		; get the changes
	ani	3ch		; save only the tuner bits
	jrz	y40		; if no change, just continue

;	process tuner change

	mov	a,d		; get the value
	ani	3ch		; check for zero selected...
	cpi	3ch		; see if all are off
	jrz	y40		; and skip if none selected

	sta	tuner		; and store in memory
	call	dsptune		; and show the value


;	check for changes in the softpot

y40:	mov	a,e		; load the change bits
	ani	03h		; look for a change
	rz			; exit if not any change here...

	mov	a,d		; read the value
	ani	3h
	sta	pstate		; save the value
	call	dspsoft		; and show the value

	ret			; then exit

;	.page
$subtitle(process in1)

;	process changes from in1

prin1:	bit	norrev,e	; look for change in normal reverse input
	jrz	z20		; if none, continue

	bit	norrev,d	; test the new state

	lda	ibpq		; load the current image for bpq
	res	norm,a		; clear the control bit
	jrz	z10		; if zero, we are done..
	set	norm,a		; set the bit
z10:	sta	ibpq		; restore the image
	sta	bpq		; and the output

	call	dspnr		; show the normal reverse state

;	see what mode selected

z20:	mov	a,e		; get the changes
	ani	7h		; save low bits
	jrz	z50		; check for memory change

	mov	a,d		; read the value
	ani	7h		; save only three bits
	cpi	7		; see if all are high
	jrz	z50		; if zero, just continue

	sta	rtmode		; save the mode
	call	dsprtmd		; show the mode...


;	look for change in the memory selection

z50:	mov	a,e		; read the changes
	ani	38h		; test for change in 3 bits
	jz	stoit		; if none, continue

	mov	a,d		; read the selection
	rrc
	rrc
	rrc
	ani	07h
	sta	memsel
	call	dspmsel		; show the selection

;	check to see if the store button is pressed...
;	if so, loop for a bit, grab the data and store in the proper
;	memory, then exit

stoit:	mov	a,e		; read the change
	ani	40h		; test for change
	rz			; exit if no change

	mov	a,d		; now, test the new state
	ani	40h		; test again

	sta	storeb		; save the bit state
	call	dspstor

	ret			; and exit	

;	.page
$subtitle(process in2)

;	change found in input in2

prin2:	bit	fminp,e		; change in am/fm bit?
	jrz	aa20		; if not, continue

	bit	fminp,d		; test the new state

	lda	istb		; load the image
	res	amfm,a		; clear the control bit
	jrz	aa10		; and skip if should be cleared
	set	amfm,a		; else turn it on
aa10:	sta	istb		; update the image
	sta	stb		; and the output

	call	dspdm

;	look for change in detect mode

aa20:	mov	a,e		; get the changes
	ani	78h		; look at only 4 bits
	jrz	aa50		; continue if no change

	mov	a,d		; load the new state
	rlc			; left justify the state
	mvi	b,4		; set the length
aa30:	rlc			; wait for nc to show selection
	jrnc	aa40		; exit on nc
	djnz	aa30		; loop til done with all
aa40:	mov	a,b		; recover the count
	dcr	a		; convert to actual detector code
	ani	3h		; save only two low bits if -1

	rlc
	rlc
	rlc
	rlc			; put it into the correct place
	mov	c,a		; save for a bit
	lda	istb		; load the current value
	ani	0cfh		; clear the destination bits
	ora	c		; combine with the new input
	sta	istb		; store it
	sta	stb

	call	dspdm

;	look for changes in antispace

aa50:	bit	aspinp,e	; see if change
	jrz	aa70			; exit if none

	bit	aspinp,d	; test the input

	lda	istb		; load the image
	res	antisp,a	; clear the bit
	jrz	aa60		; continue if already correct
	set	antisp,a	; set the bit
aa60:	sta	istb		; restore the image
	sta	stb		; and latch the new control signals

	call	dspasp

;	check for display change

aa70:	mov	a,e
	ani	02h
	jrz	aa90

	bit	mkdsp,d		; see the state
	jrz	aa80
	ori	1h		; set the bit	
aa80:	sta	dspsel
	call	dspdsel

aa90:	mov	a,e
	ani	04h
	rz

	bit	spdsp,d		; see the state
	jrz	aa100
	ori	1h		; set the bit	
aa100:	sta	dspsel
	call	dspdsel

	ret			; then exit...

;	.page
$subtitle(process in 3)

;	process changes on in3


prin3:	ani	1fh		; look for changes in regen
	jrz	bb10		; exit if not any found

	mov	a,d		; see if all zero
	ani	1bh		; if so, just exit
;	cpi	1fh		; see if none selected
;	jrz	bb10

	sta	rgmode		; save the new state
	call	dsprgen

;	check for change in baud display select switch

bb10:	mov	a,e		; recover the changes
	ani	20h
	rz

	bit	bddsp,d		; test the state
	jrz	bb20
	ori	01h		; set the bit
bb20:	sta	dspsel		; save it
	call	dspdsel

	ret			; then we are done...

;	.page
$subtitle(display utilities)

;	utility display routines - show the current setting of
;	various parameters

;	show the display selections - variable in dspsel

mkds0:	db	'\r\n'
	db	' -- MARK'
	db	$ff

mkds1:	db	'\r\n'
	db	' -- CENTER'
	db	$ff

spds0:	db	'\r\n'
	db	' -- SPACE'
	db	$ff

spds1:	db	'\r\n'
	db	' -- SHIFT'
	db	$ff

bdds0:	db	'\r\n'
	db	' -- INPUT BAUD'
	db	$ff

bdds1:	db	'\r\n'
	db	' -- OUTPUT BAUD'
	db	$ff

dsend:	db	' Display Select'
	db	$ff

dspdsel:
	lda	dspsel
	bit	mkdsp,a
	jrz	cc10

;	change in mark display selection

	lxi	h,mkds0
	rrc
	jrnc	cc70
	lxi	h,mkds1
	jmpr	cc70

cc10:	bit	spdsp,a
	jrz	cc20

;	change in space display selection

	lxi	h,spds0
	rrc
	jrnc	cc70
	lxi	h,spds1
	jmpr	cc70

cc20:	bit	bddsp,a
	rz

;	change in mark display selection

	lxi	h,bdds0
	rrc
	jrnc	cc70
	lxi	h,bdds1

cc70:	call	outstr

	lxi	h,dsend
	call	outstr
	ret


;	show softpot changes

spmsg:	db	'\r\n'
	db	' -- Soft Pot State: '
	db	$ff
spmod1:	db	'LOW'
	db	$ff
spmod2:	db	'HIGH'
	db	$ff

dspsoft:
	lda	pstate		; see if in either 00 or 11
	ana	a
	jrz	dd10
	cpi	3
	rnz

dd10:	lxi	h,spmsg
	call	outstr

	lda	pstate
	ana	a
	lxi	h,spmod1
	jrz	dd20
	lxi	h,spmod2
dd20:	call	outstr
	ret


;	show the tuner selection

tumsg:	db	'\r\n'
	db	' -- Tuner Mode: '
	db	$ff
tutrk:	db	'TRACK'
	db	$ff
tumrk:	db	'MARK'
	db	$ff
tuspa:	db	'SPACE'
	db	$ff
tubd:	db	'BAUD'
	db	$ff

dsptune:
	lxi	h,tumsg
	call	outstr

	lda	tuner		; load the mode
	lxi	h,tutrk
	bit	seltrk,a
	jrz	ee10

	lxi	h,tumrk
	bit	selmrk,a
	jrz	ee10

	lxi	h,tuspa
	bit	selspa,a
	jrz	ee10

	lxi	h,tubd
	bit	selbd,a
	jrz	ee10

	lxi	h,none

ee10:	call	outstr
	ret


;	show the memory mode setting

rtmsg:	db	'\r\n'
	db	' -- RX/TX Mode: '
	db	$ff

rvtvm:	db	'VAR RX & TX'
	db	$ff
rvtmm:	db	'VAR RX, MEMORY TX'
	db	$ff
rmtmm:	db	'MEMORY RX & TX'
	db	$ff
none:	db	' NONE??'
	db	$ff

dsprtmd:
	lxi	h,rtmsg
	call	outstr

	lda	rtmode		; load the mode indicator
	lxi	h,rvtvm
	bit	vrvt,a		; see if variable both
	jrz	ff10

	lxi	h,rvtmm
	bit	vrmt,a
	jrz	ff10

	lxi	h,rmtmm
	bit	mrmt,a
	jrz	ff10

	lxi	h,none
ff10:	call	outstr
	ret

;	memory select switch

msmsg:	db	'\r\n'
	db	' -- Memory: '
	db	$ff

dspmsel:
	lxi	h,msmsg
	call	outstr

	lda	memsel		; load the pointer
	cma
	ani	07h
	inr	a
	call	outnr		; and send it

	ret

	
;	store button

stom1:	db	'\r\n'
	db	' -- STORE Button '
	db	$ff
stoon:	db	'PUSHED'
	db	$ff
stooff:	db	'NOT PUSHED'
	db	$ff

dspstor:
	lxi	h,stom1
	call	outstr

	lda	iin1		; read the internal value
	bit	mstore,a	; now test the state 0 means pushed
	lxi	h,stoon
	jrz	gg10
	lxi	h,stooff
gg10:	call	outstr
	ret

;	detector mode setting...

mdmode:	db	'\r\n'
	db	' -- DETECTOR MODE: '
	db	$ff
mam:	db	'AM-'
	db	$ff
mfm:	db	'FM-'
	db	$ff
mdm0:	db	'SO '
	db	$ff
mdm1:	db	'MO '
	db	$ff
mdm2:	db	'MP '
	db	$ff
mdm3:	db	'M/S'
	db	$ff

dspdm:	lxi	h,mdmode	; load the string
	call	outstr		; show the message

	lda	istb		; load the variable
	bit	amfm,a		; test for am/fm
	lxi	h,mfm		; z means fm
	jrz	hh10
	lxi	h,mam		; nz means am
hh10:	call	outstr		; show that

	lda	istb		; re-load variable
	rrc			; rotate right 4 times
	rrc
	rrc
	rrc
	ani	3		; save low two bits
	lxi	h,mdm0		; set so mode
	jrz	hh20

	lxi	h,mdm1		; set mo
	dcr	a
	jrz	hh20

	lxi	h,mdm2		; mp
	dcr	a
	jrz	hh20

	lxi	h,mdm3		; set to m/s
hh20:	call	outstr		; show the message
	ret			; and exit

;	now antispace

masp:	db	'\r\n'
	db	' -- ANTISPACE: '
	db	$ff

dspasp:	lxi	h,masp		; set the message pointer
	call	outstr		; show the string

	lda	istb
	bit	antisp,a	; z means off, nz is on
	lxi	h,mson
	jrnz	ii10
	lxi	h,msoff
ii10:	call	outstr		; show the message	
	ret			; and exit

;	normal/rev

mnrev:	db	'\r\n'
	db	' -- POLARITY: '
	db	$ff
mnrn:	db	'NORM'
	db	$ff
mnrr:	db	'REV '
	db	$ff

dspnr:	lxi	h,mnrev
	call	outstr

	lda	ibpq		; load the latch image
	bit	norm,a		; z means normal
	lxi	h,mnrn
	jrz	jj10
	lxi	h,mnrr
jj10:	call	outstr
	ret

;	regeneration mode

mrgen:	db	'\r\n'
	db	' -- REGEN: '
	db	$ff
mrgm1:	db	'A/A'
	db	$ff
mrgm2:	db	'A/B'
	db	$ff
mrgm3:	db	'OFF'
	db	$ff
mrgm4:	db	'B/A'
	db	$ff
mrgm5:	db	'B/B'
	db	$ff

dsprgen:

	lxi	h,mrgen
	call	outstr		; send message
	
	lda	rgmode		; load the mode word

	lxi	h,mrgm3		;11 
	cpi	rgoff		;11 test for off position
	jrz	kk10		;11
		
	lxi	h,mrgm1		; start with the beginning
	bit	rgaa,a
	jrz	kk10

	lxi	h,mrgm2
	bit	rgab,a
	jrz	kk10

	lxi	h,mrgm4
	bit	rgba,a
	jrz	kk10

	lxi	h,mrgm5
	bit	rgbb,a
	jrz	kk10

	lxi	h,none

kk10:	call	outstr		; show the message
	ret


;	ptt status

mptt:	db	'\r\n'
	db	' -- PTT: '
	db	$ff
mptttx:	db	'TX '
	db	$ff
mpttrx:	db	'RX '
	db	$ff
mpttk:	db	'KOS'
	db	$ff

dspptt:	lxi	h,mptt
	call	outstr

	lda	istb		; load the latch image
	rrc			; load low two bytes
	ani	3
	lxi	h,mpttk		; 00 means kos
	jrz	ll10

	lxi	h,mpttrx	; 01 means rx
	dcr	a
	jrz	ll10

	lxi	h,mptttx	; 10 or 11 means tx
ll10:	call	outstr
	ret


;	some of the following just show on or off messages

mson:	db	'ON  '
	db	$ff
msoff:	db	'OFF '
	db	$ff
msauto:	db	'AUTO'
	db	$ff

onoff:	ana	a		; 0 means on, nz is off
	lxi	h,msoff
	jrz	mm10
	lxi	h,mson
mm10:	call	outstr		; show the response
	ret			; and exit

;	.page
$subtitle(right hand panel commands)

;	detector mode

dmproc:	cpi	9		; see if valid
	rnc			; just display if not
	cpi	3		; compare with lower limit the offset
	rc			; and exit if not valid

;	here we have a valid response
;	3:AM 4:FM 5:SO 6:MO 7:MP 8:M/S

	sui	5		; remove the offset
	jp	nn40		; skip ahead if not am/fm

	lxi	h,istb		; set pointer to memory
	inr	a		; -1 is fm, -2 is am
	jrz	nn20		; here z means set fm
	set	amfm,m		; set the am/fm bit for am
	jmpr	nn30		; and continue
nn20:	res	amfm,m		; clear that bit in memory
nn30:	mov	a,m		; read the image
	sta	stb		; and update the latch output

	ret			; now output the current status

;	change in the det mode - so, mo, mp, m/s
;	acc contains the new value - just shift it

nn40:	rlc			; must shift left 4 bits
	rlc
	rlc
	rlc			; done...
	mov	c,a		; save it
	lxi	h,istb		; load a pointer
	mov	a,m		; read current flag
	ani	0cfh		; 
	ora	c		; combine the new bits
	mov	m,a		; put it back
	sta	stb		; update the latch also
	ret			; and exit


;	.page
$subtitle(regen channel routines)

;	these routines deal with the DART responsible for the
;	regeneration operations.  The interrupt routines come
;	first, followed by the background polling routines

;	the ignore routine

ignore:	ei			; just return for these
	reti			; since not much else to do...


;	tx data input routine will read a char, and store it in the
;	txdsav register

txdin:	push	psw		; save acc
	in	txdata		; read the data char
	sta	txdsav		; store that char
	pop	psw
	ei
	reti			; and exit

	
;	rx data input routine will read a char from modem, and store it in the
;	rxdsav register

rxdin:	push	psw		; save acc
	in	rxdata		; read the char from the dart
	sta	rxdsav		; save it
	pop	psw		; recover flags
	ei
	reti			; and exit

;	if an error occurs, just reset and exit...

txderr:	push	psw		; save acc
	in	txstat		; read reg 0 to reset interrupt bit
	mvi	a,30h		; load the reset code
	out	txstat		; reset the error condx
	pop	psw		; recover acc
	ei			; enable interrupts
	reti			; and continue processing

rxderr:	push	psw		; save acc
	in	rxstat		; read reg 0 to reset interrupt bit
	mvi	a,30h		; load the reset code
	out	rxstat		; reset the error condx
	pop	psw		; recover acc
	ei			; enable interrupts
	reti			; and continue processing

;rd  Debug Options   

;These routines are used to trouble shoot specific
;hardware failures

dopt:	db	'\r\n\n'
	db	'Debug Options\r\n\n'
	db	' 1 ... Ram Debug\r\n'
	db	' 2 ... Display Debug\r\n'
	db	' 3 ... Control Bit Debug\r\n'
	db	' 4 ... Switch Debug\r\n'
	db	' 5 ... Oscillator Debug\r\n'
	db	' 6 ... Latch Debug\r\n\n'	;12 latch option
	db	' CR .. Return To Test Options\r\n'
	db	$ff

debug:	sta	sanity		;rd  reset sanity timer
	lxi	h,dopt		;rd  load hl with text pointer
	call	outstr		;rd  print debug options

	lxi	h,prompt	;rd  load hl with text pointer
	call	outstr		;rd  print prompt
dget:	sta	sanity		;rd  reset sanity timer
	call	codin		;rd  get choice

	cpi	cr
	jz	sta0		;rd  return to main options

	cpi	'1'
	jz	dmem		;rd  goto memory debug options
	
	cpi	'2'
	jz	ddisp		;rd  goto display debug

	cpi	'3'
	jz	dcont		;rd  goto coontrol signal debug

	cpi	'4'	
	jz	dsw		;rd  goto switch debug

	cpi	'5'
	jz	dosc		;rd  goto oscillator debug

	cpi	'6'		;12  goto latch debug
	jz	dlatch		;12  add latch debug option

	mvi	a,07h		;rd  load acc with bell character
	call	outchr		;rd  beep beeper on terminal
	jmpr	dget		;rd  goto get another character

;Memory Debug Options

;The debug memory routine has 2 options.  They are display memory 
;contents and fill memory with a character.

dmopt:	db	'\r\n\n'
	db	'Memory Debug\r\n\n'
	db	' 1 ... Display Memory Contents\r\n'
	db	' 2 ... Fill Memory\r\n\n'
	db	' CR .. Return To Debug Options\r\n\n'
	db	$ff

dmem:	sta	sanity		;rd  reset sanity timer
	lxi	h,dmopt		;rd  load hl with text pointer
	call	outstr		;rd  print memory debug options

	lxi	h,prompt	;rd  load hl with text pointer
	call	outstr		;rd  print prompt pointer
dmem1:	call	codin		;rd  get choice

	cpi	cr
	jz	debug		;rd  return to debug options
	
	cpi	'1'
	jz	dm1		;rd  goto display memory contents

	cpi	'2'
	jz	dm2		;rd  goto fill memory

	mvi	a,07h		;rd  load acc with bell character
	call	outchr		;rd  beep beeper
	jmp	dmem1		;rd  return for another choice

;Display memory contents

dm1:	mvi	d,20		;rd  load d with line counter
	mvi	e,10h		;rd  load e with byte counter
	lxi	h,ram		;rd  load hl with memory pointer

oo1:	call	crlf		;rd  send cr lf
	mov	a,h		;rd  get h part of address
	call	hexp		;rd  print it
	mov	a,l		;rd  get l part of address
	call	hexp		;rd  print it

	mvi	a,$20		;rd  load acc with space character
	call	outchr		;rd  print space betweem address and data

oo2:	mov	a,m		;rd  get data byte
	call	hexp		;rd  print data byte
	mvi	a,$20		;rd  load acc with space character
	call	outchr		;rd  print space between data bytes
	inx	h		;rd  increment memory pointer

	dcr	e		;rd  decrement byte counter
	jrnz	oo2		;rd  print e number of bytes

	mvi	e,10h		;rd  reset byte counter
	dcr	d		;rd  decrement line counter
	jrnz	oo1		;rd  print d number of lines

	push	h		;rd  save contents of hl
	mvi	d,20		;rd  reset line counter
	lxi	h,dm1txt	;rd  load hl with text pointer
	call	outstr		;rd  print return instruction
	pop	h		;rd  restore memory address
	call	codin		;rd  get choice

	cpi	cr	
	jz	dmem		;rd  return to memory debug options
	jmpr	oo1		;rd  print another page of data

dm1txt:	db	'\r\n\n'
	db	'Press Space To Display More Memory,  CR To Exit\r\n'
	db	$ff

;Fill Memory

dm2:	sta	sanity		;rd  reset sanity timer
	lxi	h,dm2txt	;rd  load hl with text pointer
	call	outstr		;rd  print test message

	call	codin		;rd  get character
	cpi	cr
	jz	dmem		;rd  return to memory debug options
	mov	d,a		;rd  otherwise store 1st character in d
	call	outchr		;rd  echo input character


	call	codin		;rd  get character
	cpi	cr
	jz	dm2		;rd  retry test if cr here
	mov	e,a		;rd  otherwise store 2nd character in e
	call	outchr		;rd  echo character

	call	hexc		;rd  convert 2 characters in de to 1 in acc
	lxi	h,ram		;rd  load hl with start of memory
	mov	d,a		;rd  store pattern in d
	mvi	b,ramend	;rd  load b with end of memory

pp1:	mov	m,d		;rd  store character in memory
	sta	sanity		;rd  reset sanity timer
	inx	h		;rd  increment memory pointer
	mov	a,h		;rd  get h part of address
	cmp	b		;rd  check for end of memory
	jrnz	pp1		
	jmp	dm1		;rd  after memory is filled  display 1st 20 
				;rd   lines
	
dm2txt:	db	'\r\n\n'
	db	'Enter Fill Character  or  CR To Exit\r\n\n'
	db	' > '
	db	$ff

;Hex to Ascii Convert

;This routine takes the contents of the de registers and converts
;them to 1 hex character and returns with that character in the
;accumulator.	

hexc:	mov	a,d		;rd  get the ascii character in d
	ori	20h		;rd  make sure it is upper case
	cpi	61h		;rd  check to see if it is 0-9 or a-f
	jrnc	qq1

	sui	30h		;rd  subtract 30 from 0-9 character
	jmpr	qq2
qq1:	sui	57h		;rd  subtract 57 from a-f character
qq2:	rrc
	rrc			;rd  move this char into the upper 4 bits
	rrc
	rrc
	ani	0f0h		;rd  zero lower 4 bits
	mov	d,a		;rd  save it in d

	mov	a,e		;rd  get character in e
	ori	20h		;rd  make sure it is in upper case
	cpi	61h		;rd  check for 0-9 or a-f charatcer
	jrnc	qq3

	sui	30h		;rd  subtract 30 from 0-9 character
	jmpr	qq4
qq3:	sui	57h		;rd  subtract 57 from a-f character
qq4:	ani	0fh		;rd  zero upper 4 bits
	ora	d		;rd  combine the 2 characters
	ret			;rd  return with character in acc
;Display debug routine

;This routine turns the selected display on and then off and repeats
;this until a key is pressed.

disptxt:db	'\r\n\n'
	db	'Display Debug\r\n\n'
	db	'Writing All Display Segments  Press CR To Exit\r\n\n'
	db	$ff
	
ddisp:	lxi	h,disptxt	;rd  load hl with text pointer
	call	outstr		;rd  print display debug options
	
ddsp1:	lxi	h,dsplrx	;rd  load hl with display refresh storage
	mvi	b,12		;rd  load b with number of digits
rr1:	mvi	m,$ff	;rd  write 1 to all digits
	inx	h		;rd  increment display pointer
	djnz	rr1		;rd  zero all 12 diggits
 
	call	delay		;rd  delay for a bit

	lxi	h,dsplrx	;rd  load hl with display pointer
	mvi	b,12		;rd  load b with the number of digits 
rr11:	mvi	m,0		;rd  zero display digits

  	inx	h		;rd  increment display pointer
	djnz	rr11		;rd  zero b number of digits

	call	delay		;rd  wait for a bit

	in	costat		;rd  get console status
	ani	2		;rd  check for a key press
	jrz	ddsp1		;rd  if no key press  repeat test
	in	codata		;rd  get key press
	jmp	debug		;rd  return to debug options



;Delay routine
;This delay is to allow the operator to see the digits change

delay:	lxi	d,6000h		;rd  lad delay value
ss1:	dcx	d		;rd  decrement delay counter
	sta	sanity		;rd  reset sanity timer

	mov	a,d
	ora	e		;rd  check for 0
	jrnz	ss1		;rd  wait till count reaches 0
	ret

;Control signal debug	
;This routine turns all the control signals on then turns them all off
;and repeats this untill a key is pressed

dctxt:	db	'\r\n\n'
	db	'Control Signal Debug  Press CR To Exit\r\n\n'
	db	$ff

dcont:	lxi	h,dctxt		;rd  load hl with text pointer
	call	outstr		;rd  print we are here message

tt1:	mvi	a,0beh
	sta	stb		;rd  turn all stb signals on
	mvi	a,0
	sta	mkspq		;rd  turn on all mkspq signals
	mvi	a,93h
	sta	bpq		;rd  turn on all bpq signals

	call	delay		;rd  wait a bit

	mvi	a,41h	
	sta	stb		;rd  turn off all stb signals
	mvi	a,-1
	sta	mkspq		;rd  turn off all mkspq signals
	mvi	a,6ch
	sta	bpq		;rd  turn off all bpq signals

	call	delay		;rd  wait for a bit
	
	in	costat		;rd  get console status
	ani	2		;rd  check for key press
	jrz	tt1

	in	codata		;rd  get character
	jmp	debug		;rd  return to debug options

;Switch debug

;This routine reads all the switch registers and repeats until a key is 
;pressed

dswtxt:	db	'\r\n\n'
	db	'Switch Debug\r\n\n'
	db	'Reading The Switch Registers  Press CR To Exit\r\n\n'
	db	$ff

dsw:	lxi	h,dswtxt	;rd  load hl with text pointer
	call	outstr		;rd  print switch debug message

uu1:	in	in0		;rd  read switch register 0
	in	in1		;rd  read switch register 1
	in	in2		;rd  read switch register 2
	in	in3		;rd  read switch register 3

	sta	sanity		;rd  reset sanity timer

	in	costat		;rd  read console status
	ani	2		;rd  check for key press
	jrz	uu1		;rd  loop on read until key is pressed

	in	codata		;rd  get data	
	jmp	debug		;rd  return to debug options

;Oscillator Debug

;This routine loops on a write of ff to all the oscillator latches
;until the space bar is pressed  then it loops on a write of 00 to the
;oscillator latches untill the space bar is pressed.  Then it goes back to
;write ff.  This cycle repeats until the cr is pressed.

otxt1:	db	'\r\n\n'
	db	"Writing 1's To The Oscillator Latches\r\n"
	db	"Press CR To Exit   Space Bar To Write 0's\r\n\n"
	db	$ff

otxt2:	db	'\r\n\n'
	db	"Writing 0's To The Oscillator Latches\r\n"
	db	"Press CR To Exit  Space Bar To Write 1's\r\n\n"
	db	$ff

dosc:	lxi	h,otxt1		;rd  load hl with text pointer
	call	outstr		;rd  print 1st debug message

vv1:	mvi	a,$ff	;rd  load acc with ff
	sta	mkshl		;rd  write mark shift low
	sta	spshl		;rd  write space tone low
	sta	spshh		;rd  write space tone high
	sta	mkbpl		;rd  write mark bandpass low
	sta	mkbph		;rd  write mark bandpass high
	sta	spbpl		;rd  write space bandpass low
	sta	spbph		;rd  write space bandpass high
	sta	bpl		;rd  write bandpass low
	sta	bph		;rd  write bandpass high
	sta	lpl		;rd  write lowpass low
	sta	lph		;rd  write lowpass high

	sta	sanity		;rd  reset sanity timer
	in	costat		;rd  read console status
	ani	2		;rd  check for key press
	jrz	vv1		;rd  loop on write until key is pressed

	in	codata		;rd  read data
	cpi	cr		;rd  check for cr
	jrnz	vv3

vv2:	call	linit		;rd  init oscillators
	jmp	debug		;rd  return to debug options

vv3:	lxi	h,otxt2		;rd  load hl with text pointer
	call	outstr		;rd  print 2nd debug message

vv4:	mvi	a,0		;rd  write 0 to all the latches
	sta	mkshl		;rd  write mark shift low
	sta	spshl		;rd  write space tone low
	sta	spshh		;rd  write space tone high
	sta	mkbpl		;rd  write mark bandpass low
	sta	mkbph		;rd  write mark bandpass high
	sta	spbpl		;rd  write space bandpass low
	sta	spbph		;rd  write space bandpass high
	sta	bpl		;rd  write bandpass low
	sta	bph		;rd  write bandpass high
	sta	lpl		;rd  write low pass low
	sta	lph		;rd  write low pass high

	sta	sanity		;rd  reset sanity timer
	in	costat		;rd  read console status
	ani	2		;rd  check for key press
	jrz	vv4		;rd  loop on write untill a keypress

	in	codata		;rd  get key
	cpi	cr	
	jz	vv2		;rd  return on cr
	jmp	dosc		;rd  otherwise start over
	
;Latch Debug

;12	
;This routine is for displaying a page of latch debugging
;options for the tone generator and the filter synthesizers.


lopt:	db	'\r\n'
	db	' 1 ... Mark/Space Tone Generator \r\n'
	db	' 2 ... Mark Filter \r\n'
	db 	' 3 ... Space Filter \r\n'
	db	' 4 ... Band-Pass Filter \r\n'
	db	' 5 ... Low-Pass Filter \r\n'
	db	$ff

checkd:	lxi	h,lout		;12
	call	outstr		;12
	mov	d,a		;12
	call	outstr		;12

	lxi	h,fout		;12
	call	outstr		;12
	push	psw		;12 save the data value

ww1:	sta	sanity		;12
	in	costat		;12
	ani	2		;12
	jrz	ww1		;12

	in	codata		;12
	cpi	cr		;12
	jz	ww2		;12
	
	pop	psw		;12 restore data value
	rrc			;12
	ret			;12

ww2:	call	linit		;12
	jmp	debug		;12

tongen:	ret			;12
splat:	ret			;12
bplat:	ret			;12
lplat:	ret			;12

dlatch:	sta	sanity		;12 reset sanity timer
	lxi	h,lopt		;12 load hl with text pointer
	call	outstr		;12 print latch options
	
	lxi	h,prompt	;12 load hl with text pointer	
	call	outstr		;12 print command prompt
lget:	sta 	sanity		;12 reset sanity timer
	call 	codin		;12 get choice

	cpi	cr		;12 
	jz	debug		;12 return to debug options

	cpi	'1'		;12
	jz	tongen		;12 goto tone generator debug

	cpi	'2'		;12
	jz	mklat		;12 goto mark latch debug

	cpi	'3'		;12
	jz	splat		;12 goto space latch debug

	cpi	'4'		;12
	jz	bplat		;12 goto band-pass latch debug

	cpi	'5'		;12
	jz	lplat		;12 goto low-pass latch debug

	mvi	a,07h		;12 load acc with bell character
	call 	outstr		;12 beep beeper on terminal
	jmpr	lget		;goto get another character


;Mark Latch Debug Option

;12
;This routine writes a 1 to each bit, one bit at a time, starting
;with D7. The loaded value and the expected frequency is displayed
;on the screen. Any key other than a \r changes the next bit and
;wraps back around to D7. A \r returns the user to the main debug
;options.

mopt:	db	'\r\n'
	db	' Mark Latch Debug'
	db	'\r\n\r\r\r'
	db	' Press CR to exit\r\n'
	db	' Any other key to cycle next bit'
	db	'\r\n\r\r'
	db	$ff

lout:	db	'\r\n'
	db	' Loaded Latch Data is  '
	db	$ff

fout:	db	'\r\n\r'
	db	' Expected output frequency (U43$ff2) is '
	db	$ff

	
mklat:	sta	sanity		;12 reset sanity timer
	lxi	h,mopt		;12 load hl with text pointer
	call	outstr		;12 print test instructions

xx3:	mvi	a,0		;12 write 0's to mark low
	sta	mkbpl		;12

;temporary 	
	mvi	a,80h		;12 load mark high-set high bit
	sta	mkbph		;12
	sta     sanity		;12 test
	jmp	xx3		;test

xx1:	call	checkd		;12 go check for new data
	cpi	10h		;12 end of high byte?
	jz	xx2		;12 if so, go on to low byte
	jmp     xx1		;12 otherwise continue

xx2:	mvi	a,0		;12 write 0's to mark high
	sta	mkbph		;12

	mvi	a,80h		;12 load mark low-set high bit
	sta	mkbpl		;12 store that value

yy2:	call	checkd		;12 go check for new data
	cpi	00h		;12 end of low byte?
	jz	mklat		;12 if yes, start over 
	jmp	yy2		;12 otherwise keep going
		
	

	end